//
// Created by zhuyuanshuo on 16/8/4.
//
#include <string.h>
#include <android/bitmap.h>
#include <jni.h>
#include <android/log.h>

/**
 * Explicitly marks result of an expression as unused.
 *
 * We instruct the compiler to be very strict when it comes to code
 * like unused arguments that could indicate a bug. Because of that, handling
 * intentionally unused arguments requires tricks like casting to void. This
 * macro provides a readable name for this operation.
 */
#define UNUSED(expr) ((void) (expr));
#define LOGD(...) __android_log_print(ANDROID_LOG_DEBUG, "keymatch", __VA_ARGS__)

static jclass runtime_exception_class;

static void safe_throw_exception(JNIEnv* env, const char* msg) {
  if (!(*env)->ExceptionCheck(env)) {
    (*env)->ThrowNew(env, runtime_exception_class, msg);
  }
}


/*
 * Class:     com_wlx_common_imagecache_resource_Bitmaps
 * Method:    nativePinBitmap
 * Signature: (Landroid/graphics/Bitmap;)V
 */
JNIEXPORT void JNICALL Java_com_wlx_common_imagecache_resource_Bitmaps_nativePinBitmap
  (JNIEnv* env, jclass clazz, jobject bitmap){
  UNUSED(clazz);
    int rc = AndroidBitmap_lockPixels(env, bitmap, 0);
    if (rc != ANDROID_BITMAP_RESULT_SUCCESS) {
      safe_throw_exception(env, "Failed to pin Bitmap");
    }
//  LOGD("pinbitmap by commonlib");
  }
